<?php
/*
Plugin Name: 123 Tools
Plugin URI: http://schnurpsel.de/wordpress-plugins/123-tools/
Description: Sammlung kleiner, nützlicher Helferlein (siehe Optionen), für die es sich nicht lohnen würde, extra Plugins zu schreiben.
Author: Ingo Henze
Version: 0.26
Author URI: http://putzlowitsch.de/
*/ 

if( !defined( 'PLW123TO_DEBUG' ) )
	define( 'PLW123TO_DEBUG', false );
// Falls nicht vorhanden, plw123_debugfile_write Dummy definieren
if ( !function_exists('plw123_debugfile_write') ) :
function plw123_debugfile_write( $message) {
}
endif;

// Einstellungen für das Plugin

// Einstellungen laden
$plw123to_options = get_option( 'plw123to_options' );
// noch keine vorhanden, dann mit Default-Werten vorbelegen
if( !is_array( $plw123to_options ) ) {
	$plw123to_options = array(
		'use_nocomment' => false,   // Kommentarfunktion ausschalten 
		'use_nodbextras' => true,   // Im Tellerrand keine Extras anzeigen 
		'use_noqpress' => false,    // kein Quick-Press im Dashboard (ab WP 2.7) 
		'use_nopreview' => false,   // Beim Bearbeiten unten keine Vorschau anzeigen 
		'use_noupload' => false,    // Uploadfunktion deaktivieren 
		'use_noedit' => false,      // Bearbeiten und erstellen von Beiträgen und Seiten deaktivieren 
		'max_thumbsize' => 0,    		// Maximale Seitenlänge der beim Upload erzeugten Vorschaubilder (0 = WP-Vorgabe 128)
		'sticky_offset' => 0,    		// Offset, ab dem die Sticky-Artikel angezeigt werden (ab WP 2.7)
		'post_prefill' => '', 			// Vorbelegung eines Artikels
		'page_prefill' => '',				// Vorbelegung einer Seite
		'version_fake' => '',				// Ausgabe einer "Fake"-Version
		'use_nocoreupd'  => true,   // Keine WP-Core-Updatecheck
		'use_nopluginupd'  => true, // Keine Plugin-Updatecheck
		'use_nothemeupd'  => true,  // Keine Theme-Updatecheck
		'use_nohostlink'  => false, // Hostname in Links entfernen (zur Wurzel relative Links)
		'use_feedhost' => false,    // Hostname in Feeds erzwingen 
		'use_noheaderrsd' => false, // Kein RSD-Link (EditURI mit xmlrpc)  im header
		'use_noheaderman' => true,  // Kein Manifest-Link (wlwmanifest) im Header
		'use_noheaderver' => false, // Keine WP-Versionsinfo (generator) im Header
		'use_noheaderrel' => false, // Keine Rel-Links (index,parent,start,adjacent) im Header
		'use_noversion' => false  	// Keine Versionsinfo (Seite, Feed usw.) (ab WP 2.5)
	);
}
// wenn vorhanden, gegebenenfalls fehlende mit Default-Werten vorbelegen
else {
	if( !array_key_exists( 'use_nocomment', $plw123to_options ) )
		$plw123to_options['use_nocomment'] = false;
	if( !array_key_exists( 'use_nodbextras', $plw123to_options ) )
		$plw123to_options['use_nodbextras'] = true;
	if( !array_key_exists( 'use_noqpress', $plw123to_options ) )
		$plw123to_options['use_noqpress'] = false;
	if( !array_key_exists( 'use_nopreview', $plw123to_options ) )
		$plw123to_options['use_nopreview'] = false;
	if( !array_key_exists( 'use_noupload', $plw123to_options ) )
		$plw123to_options['use_noupload'] = false;
	if( !array_key_exists( 'use_noedit', $plw123to_options ) )
		$plw123to_options['use_noedit'] = false;
	if( !array_key_exists( 'max_thumbsize', $plw123to_options ) )
		$plw123to_options['max_thumbsize'] = 0;
	if( !array_key_exists( 'sticky_offset', $plw123to_options ) )
		$plw123to_options['sticky_offset'] = 0;
	if( !array_key_exists( 'post_prefill', $plw123to_options ) )
		$plw123to_options['post_prefill'] = '';
	if( !array_key_exists( 'page_prefill', $plw123to_options ) )
		$plw123to_options['page_prefill'] = '';
	if( !array_key_exists( 'version_fake', $plw123to_options ) )
		$plw123to_options['version_fake'] = '';
	if( !array_key_exists( 'use_nocoreupd', $plw123to_options ) )
		$plw123to_options['use_nocoreupd'] = true;
	if( !array_key_exists( 'use_nopluginupd', $plw123to_options ) )
		$plw123to_options['use_nopluginupd'] = true;
	if( !array_key_exists( 'use_nothemeupd', $plw123to_options ) )
		$plw123to_options['use_nothemeupd'] = true;
	if( !array_key_exists( 'use_nohostlink', $plw123to_options ) )
		$plw123to_options['use_nohostlink'] = false;
	if( !array_key_exists( 'use_feedhost', $plw123to_options ) )
		$plw123to_options['use_feedhost'] = false;
	if( !array_key_exists( 'use_noheaderrsd', $plw123to_options ) )
		$plw123to_options['use_noheaderrsd'] = false;
	if( !array_key_exists( 'use_noheaderman', $plw123to_options ) )
		$plw123to_options['use_noheaderman'] = true;
	if( !array_key_exists( 'use_noheaderver', $plw123to_options ) )
		$plw123to_options['use_noheaderver'] = false;
	if( !array_key_exists( 'use_noheaderrel', $plw123to_options ) )
		$plw123to_options['use_noheaderrel'] = false;
	if( !array_key_exists( 'use_noversion', $plw123to_options ) )
		$plw123to_options['use_noversion'] = false;
}

// Null-Funktion
function plw123to_return_null () {
	return null;
}

if( $plw123to_options['use_nocomment'] ) {
	function plw123to_the_posts( $posts ) {
	  $postcount = count( $posts ); 
	  
		for( $i=0; $i<$postcount; $i++ ) {
			$posts[$i]->comment_status = 'closed';
			$posts[$i]->ping_status = 'closed';
		}
		return $posts;
	}
	function plw123to_cp_open( $open, $post_id ) {
		return false;
	}
	add_filter( 'the_posts', 'plw123to_the_posts' );
	add_filter( 'pings_open', 'plw123to_cp_open', 10, 2 );
	add_filter( 'comments_open', 'plw123to_cp_open', 10, 2 );
}

if( $plw123to_options['use_nodbextras'] ) {
	function plw123to_admin_print_scripts() {
		remove_action( 'admin_head', 'index_js' ); 
	}
	add_action( 'admin_print_scripts', 'plw123to_admin_print_scripts' );
	// WP 2.5, 2.6
	if( version_compare( get_bloginfo('version'), '2.7', '<') ) {
		function plw123to_remove_dashboard_widgets( $dashboard_widgets ) {
			// echo "Dashboard 2.5";
			return array( 'dashboard_recent_comments' );
		}
		add_filter( 'wp_dashboard_widgets', 'plw123to_remove_dashboard_widgets' );
	}	
	// WP 2.7
	else {
		// echo "Dashboard 2.7";
		function plw123to_dashboard_setup() {
			$remove_list = array( 'dashboard_primary', 'dashboard_secondary', 'dashboard_incoming_links', 'dashboard_plugins' );
			foreach( $remove_list as $remove ) {
				remove_meta_box( $remove, 'dashboard', 'normal' );
				remove_meta_box( $remove, 'dashboard', 'side' );
			}
		}
		add_action( 'wp_dashboard_setup', 'plw123to_dashboard_setup' );
	}	
}
if( $plw123to_options['use_noqpress'] ) {
	function plw123to_dashboard_noqedit() {
		remove_meta_box( 'dashboard_quick_press', 'dashboard', 'normal' );
		remove_meta_box( 'dashboard_quick_press', 'dashboard', 'side' );
	}
	add_action( 'wp_dashboard_setup', 'plw123to_dashboard_noqedit' );
}

if( $plw123to_options['use_nopreview'] ) {
	function plw123to_preview_post_link( $value ) {
		return '';
	}
	function plw123to_admin_head() {
		echo "<style type='text/css'>#preview { display: none; }</style>\n";
	}

	add_filter( 'preview_post_link', 'plw123to_preview_post_link');
	add_filter( 'preview_page_link', 'plw123to_preview_post_link');
	add_action( 'admin_head', 'plw123to_admin_head' );
}

if( $plw123to_options['use_noupload'] || $plw123to_options['use_noedit'] ) {
	function plw123to_user_has_cap( $allcaps, $caps, $args ){
		global $plw123to_options;
		
		if( $plw123to_options['use_noupload'] ) {
			if( 'upload_files' == $args[0] )
			  $allcaps['upload_files'] = false;
		}
		if( $plw123to_options['use_noedit'] ) {
			if( 'edit_posts' == $args[0] )
			  $allcaps['edit_posts'] = false;
			if( 'edit_pages' == $args[0] )
			  $allcaps['edit_pages'] = false;
		}
		return $allcaps;
	}
	add_filter( 'user_has_cap', 'plw123to_user_has_cap', 10, 3 );
}
function plw123to_admin_init() {
	global $plw123to_options;
	if( $plw123to_options['use_noupload'] )
		remove_action( 'media_buttons', 'media_buttons' );
}
add_action( 'admin_init', 'plw123to_admin_init' );


if( $plw123to_options['max_thumbsize'] > 0 ) {
	function plw123to_thumbnail_max_side_length( $max_side, $attachment_id, $file ) {
		global $plw123to_options;
		return $plw123to_options['max_thumbsize'];
	}
	add_filter( 'wp_thumbnail_max_side_length', 'plw123to_thumbnail_max_side_length', 10, 3 );  
}


function plw123to_prefill( $content ) {
	global $post;
	global $plw123to_options;

	if( '' == $content ) {
		switch( $post->post_type ) {
			case 'post':
				$content = stripslashes( $plw123to_options['post_prefill'] );
			break;
			case 'page':
				$content = stripslashes( $plw123to_options['page_prefill'] );
			break;
		}
	}
	return $content;
}
add_filter( 'the_editor_content', 'plw123to_prefill' );

if( $plw123to_options['use_nocoreupd'] ) :
	// WP-Update-Check entfernen
  // define( 'WP_INSTALLING', true );
  function plw123to_core_version_check_locale( $value ) {
		global $wp_current_filter;
		if( PLW123TO_DEBUG==true ) {
			plw123_debugfile_write( "wp_version_check (core_version_check_locale)" );
			plw123_debugfile_write( debug_backtrace() );
		}
		return $value;
	}
	add_filter( 'core_version_check_locale', 'plw123to_core_version_check_locale' );

	function plw123to_remove_update_core() {
		remove_action( 'init', 'wp_version_check' );
		remove_action( 'admin_init', '_maybe_update_core' );
		remove_action( 'wp_version_check', 'wp_version_check' );
		
		if( PLW123TO_DEBUG==true ) {
			plw123_debugfile_write( "plw123to_remove_update_core" );
		}	
	}
	add_action( 'admin_menu', 'plw123to_remove_update_core' );
	plw123to_remove_update_core();
	wp_clear_scheduled_hook( 'wp_version_check' );
	
	add_filter( 'pre_option_update_core', 'plw123to_return_null' );
endif;

if( $plw123to_options['use_nopluginupd'] ) :
	// Plugin-Check entfernen
	function plw123to_remove_update_plugin() {
		remove_action( 'load-plugins.php', 'wp_update_plugins' );
		remove_action( 'load-update.php', 'wp_update_plugins' );
		remove_action( 'admin_init', '_maybe_update_plugins' );
		remove_action( 'wp_update_plugins', 'wp_update_plugins' );
	}
	add_action( 'admin_menu', 'plw123to_remove_update_plugin' );
	plw123to_remove_update_plugin();
	wp_clear_scheduled_hook( 'wp_update_plugins' );

	add_filter( 'pre_option_update_plugins', 'plw123to_return_null' );
endif;

if( $plw123to_options['use_nothemeupd'] ) :
	// Theme-Check entfernen
	function plw123to_remove_update_theme() {
		remove_action( 'load-themes.php', 'wp_update_themes' );
		remove_action( 'load-update.php', 'wp_update_themes' );
		remove_action( 'admin_init', '_maybe_update_themes' );
		remove_action( 'wp_update_themes', 'wp_update_themes' );
	}
	add_action( 'admin_menu', 'plw123to_remove_update_theme' );
	plw123to_remove_update_theme();
	wp_clear_scheduled_hook( 'wp_update_themes' );

	add_filter( 'pre_option_update_themes', 'plw123to_return_null' );
endif;

function plw123to_get_rel_url( $url ) {
	$url_parts = parse_url( $url );
	if( is_array( $url_parts ) ) {
		$relurl = $url_parts['path'];
		if( isset( $url_parts['query'] ) )
			$relurl .= '?'.$url_parts['query'];
		if( isset( $url_parts['fragment'] ) )
			$relurl .= '#'.$url_parts['fragment'];
		$url = $relurl;
	}
	return $url;
}

if( $plw123to_options['use_nohostlink'] ) :
	$plw123to_nh_enabled = true; 

	function plw123to_enable_remove_hostlink() {
		global $plw123to_nh_enabled;
		$plw123to_nh_enabled = true; 
	}

	function plw123to_disable_remove_hostlink() {
		global $plw123to_nh_enabled;
		$plw123to_nh_enabled = false; 
	}
	
	function plw123to_remove_hostlink( $url ) {
		global $plw123to_nh_enabled;

		if( !is_feed() && !defined('DOING_CRON') && $plw123to_nh_enabled ) {
			$url = plw123to_get_rel_url( $url );
		}
		return $url;
	}
	$link_filters = array( 'attachment', '_get_page', 'post', 'year', 'month', 'day', 'feed', 'category', 'tag', 'get_pagenum' );
	foreach( $link_filters as $link_filter )
		add_filter( $link_filter.'_link', 'plw123to_remove_hostlink' );
	
	$url_filters = array( 'wp_get_attachment', 'bloginfo' );
	foreach( $url_filters as $url_filter )
		add_filter( $url_filter.'_url', 'plw123to_remove_hostlink' );
	// für redirect_canonical deaktivieren/aktivieren
	add_action( 'template_redirect', 'plw123to_disable_remove_hostlink', 9 );
	add_action( 'template_redirect', 'plw123to_enable_remove_hostlink', 11 );
endif;

// nur wenn relative URLs "absolutiert"  werden sollen
if( $plw123to_options['use_feedhost'] ) :
	$plw123to_hostname = $_SERVER['HTTP_HOST']; 
	
	// Filter für Funktion 'the_content_rss'
	function plw123to_content_rss( $content ) {
		global $plw123to_hostname;
		// Wird ein Feed ausgegeben?
		if( is_feed() )
		{
			// relative interne Links und Bilder "absolutieren" ( "http://" und Hostname davorsetzen)
			return preg_replace( "/<(a|img)(.+?)(href|src)=(\"|')\/(.+?)(\"|')/i", "<$1$2$3=$4http://$plw123to_hostname/$5$6", $content );
		}
		else
			return $content;
	}

	// Filter für Funktion 'get_the_guid'
	function plw123to_guid_rss( $guid ) {
		global $plw123to_hostname;
		// Wird ein Feed ausgegeben?
		if( is_feed() )
			if( $guid != '' )
				return 'http://'.$plw123to_hostname.plw123to_get_rel_url( $guid );
		return $guid;
	}
	add_filter( 'the_content', 'plw123to_content_rss', 99 );
	add_filter( 'get_comment_text', 'plw123to_content_rss', 99 );
	// add_filter( 'comment_text_rss', 'plw123to_content_rss' );
	add_filter( 'get_the_guid', 'plw123to_guid_rss' );
endif;

if( $plw123to_options['use_noheaderrsd'] ) :
	remove_action( 'wp_head', 'rsd_link' );
endif;
if( $plw123to_options['use_noheaderman'] ) :
	remove_action( 'wp_head', 'wlwmanifest_link' );
endif;
if( $plw123to_options['use_noheaderver'] ) :
	remove_action( 'wp_head', 'wp_generator' );
endif;
if( $plw123to_options['use_noheaderrel'] ) :
	remove_action( 'wp_head', 'index_rel_link' );
	remove_action( 'wp_head', 'parent_post_rel_link', 10, 0);
	remove_action( 'wp_head', 'start_post_rel_link', 10, 0);
	remove_action( 'wp_head', 'adjacent_posts_rel_link', 10, 0);
endif;

if( version_compare( get_bloginfo('version'), '2.7', '>=') ) :
$plw123to_sticky_posts = array();
	function plw123to_option_sticky_posts( $sticky_posts ) {
		global $plw123to_sticky_posts;	
		$sticky_count = count( $plw123to_sticky_posts );
		if( $sticky_count > 0 )
			$sticky_posts = $plw123to_sticky_posts; 
		remove_filter( 'option_sticky_posts', 'plw123to_option_sticky_posts' );
		return $sticky_posts;
	}
	
	function plw123to_posts_results( $posts ) {
		global $plw123to_options,$plw123to_sticky_posts;
		$plw123to_sticky_posts = get_option( 'sticky_posts' );
		if( !empty( $plw123to_sticky_posts ) ) {
			$offset = $plw123to_options['sticky_offset'];
			for( $pos = 0; $pos<$offset; $pos++ ) {
				if( !in_array( $posts[$pos]->ID, $plw123to_sticky_posts ) )
					array_unshift( $plw123to_sticky_posts, $posts[$pos]->ID );
			}
			add_filter( 'option_sticky_posts', 'plw123to_option_sticky_posts' );
		}
		return $posts;
	}
	if( $plw123to_options['sticky_offset'] > 0 ) {
		add_filter( 'posts_results', 'plw123to_posts_results' );
	}
endif;

if( '' != $plw123to_options['version_fake'] ) :
	function plw123to_bloginfo_version() {
		global $plw123to_options,$wp_version;
		if( '-' == $plw123to_options['version_fake'] )
			$wp_version = '';
		else
			$wp_version = $plw123to_options['version_fake'];
	}
	add_action( 'template_redirect', 'plw123to_bloginfo_version' );
endif;

if( $plw123to_options['use_noversion'] ) :
	function plw123to_the_generator( $value, $type ) {
		if( 'export' == $type )
			return $value;
		else
			return '';
	}
	add_filter( 'the_generator', 'plw123to_the_generator', 10, 2 );
endif;

// Admin-Panel
function plw123to_options_subpanel() {
	global $plw123to_options;

  if (isset($_POST['plw123to_update'])) {
		// Optionen
		$plw123to_options['use_nocomment'] = isset($_POST['plw123to_opt_usnc']);
		$plw123to_options['use_nodbextras'] = isset($_POST['plw123to_opt_usne']);
		$plw123to_options['use_noqpress'] = isset($_POST['plw123to_opt_usnq']);
		$plw123to_options['use_nopreview'] = isset($_POST['plw123to_opt_usnp']);
		$plw123to_options['use_noupload'] = isset($_POST['plw123to_opt_usnu']);
		$plw123to_options['use_noedit'] = isset($_POST['plw123to_opt_usnd']);
		// Wertebereich prüfen
		$value = trim($_POST['plw123to_opt_mths']);
		if( !is_numeric($value) || $value<0 ) {
		  $value = 0;
		}
		$plw123to_options['max_thumbsize'] = $value;
		
		// Wertebereich prüfen
		$value = trim($_POST['plw123to_opt_stpo']);
		if( !is_numeric($value) || $value<0 ) {
		  $value = 0;
		}
		$plw123to_options['sticky_offset'] = $value;

		$plw123to_options['post_prefill'] = $_POST['plw123to_opt_popf'];
		$plw123to_options['page_prefill'] = $_POST['plw123to_opt_pgpf'];
		// Update-check
		$plw123to_options['use_nocoreupd'] = isset($_POST['plw123to_opt_nocu']);
		$plw123to_options['use_nopluginupd'] = isset($_POST['plw123to_opt_nopu']);
		$plw123to_options['use_nothemeupd'] = isset($_POST['plw123to_opt_notu']);
	
		$plw123to_options['use_nohostlink'] = isset($_POST['plw123to_opt_usnh']);
		$plw123to_options['use_feedhost'] = isset($_POST['plw123to_opt_usfh']);

		// Seiten-Header
		$plw123to_options['use_noheaderrsd'] = isset($_POST['plw123to_opt_nohr']);
		$plw123to_options['use_noheaderman'] = isset($_POST['plw123to_opt_nohm']);
		$plw123to_options['use_noheaderver'] = isset($_POST['plw123to_opt_nohv']);
		$plw123to_options['use_noheaderrel'] = isset($_POST['plw123to_opt_nohl']);
		
		$plw123to_options['use_noversion'] = isset($_POST['plw123to_opt_nove']);
		$plw123to_options['version_fake'] = trim($_POST['plw123to_opt_verf']);

		update_option('plw123to_options', $plw123to_options );
	
    ?><div class="updated"><p><strong>Einstellungen wurden gespeichert.</strong></p></div>
	<?php
  }
	$plugindata = get_plugin_data( __FILE__ );
	?>
<script type="text/javascript">
<!--
function checkMTHS() {
	var opt_maxsize = parseInt( document.forms.plw123to_optform.plw123to_opt_mths.value );
	if( isNaN( opt_maxsize ) || opt_maxsize<0 ) {
	  opt_maxsize=0;
		document.forms.plw123to_optform.plw123to_opt_mths.value = opt_maxsize;
	}
}
function checkSTPO() {
	var opt_stpo = parseInt( document.forms.plw123to_optform.plw123to_opt_stpo.value );
	if( isNaN( opt_stpo ) || opt_stpo<0 ) {
	  opt_stpo=0;
		document.forms.plw123to_optform.plw123to_opt_stpo.value = opt_stpo;
	}
}
//-->	
</script>

<div class="wrap" style="height:100%">
  <form method="post" id="plw123to_optform" onsubmit="return createLists()">
    <h2><?php echo $plugindata['Title']; ?> Einstellungen</h2>
	<p>Plugin-Version <?php echo $plugindata['Version']; ?></p>
	<p><?php echo $plugindata['Description']; ?></p>
	<h3>Optionen:</h3>
	<table cellspacing="2" cellpadding="5" class="editform form-table">
	<tr><th><label>Keine Kommantare: </label></th><td><input type="checkbox" name="plw123to_opt_usnc" value="1" <?php if($plw123to_options['use_nocomment']) echo 'checked="checked"'; ?> /> Kommantarfunktion bei allen Beiträgen und Seiten abschalten</td></tr>
	<tr><th><label>Keine Tellerrand-Extras: </label></th><td><input type="checkbox" name="plw123to_opt_usne" value="1" <?php if($plw123to_options['use_nodbextras']) echo 'checked="checked"'; ?> /> Die Anzeige von Wordpress-Blog und -News sowie der eingehenden Links abschalten (WP &gt;= 2.1)</td></tr>
	<tr><th><label>Keine Quick-Press: </label></th><td><input type="checkbox" name="plw123to_opt_usnq" value="1" <?php if($plw123to_options['use_noqpress']) echo 'checked="checked"'; ?> /> Die Anzeige vom Quick-Press-Fenster im Dashboard abschalten (WP &gt;= 2.7)</td></tr>

	<tr><th><label>Keine Updatecheck: </label></th><td><input type="checkbox" name="plw123to_opt_nocu" value="1" <?php if($plw123to_options['use_nocoreupd']) echo 'checked="checked"'; ?> /> Es wird nicht auf eine neuere WP-Version geprüft
	<br /><input type="checkbox" name="plw123to_opt_nopu" value="1" <?php if($plw123to_options['use_nopluginupd']) echo 'checked="checked"'; ?> /> Es wird nicht auf Plugin-Updates geprüft
	<br /><input type="checkbox" name="plw123to_opt_notu" value="1" <?php if($plw123to_options['use_nothemeupd']) echo 'checked="checked"'; ?> /> Es wird nicht auf Theme-Updates geprüft</td></tr>

	<tr><th><label>Im Header: </label></th><td><input type="checkbox" name="plw123to_opt_nohr" value="1" <?php if($plw123to_options['use_noheaderrsd']) echo 'checked="checked"'; ?> /> Keinen RSD-Link (EditURI mit xmlrpc) ausgeben
	<br /><input type="checkbox" name="plw123to_opt_nohm" value="1" <?php if($plw123to_options['use_noheaderman']) echo 'checked="checked"'; ?> /> Keinen Manifest-Link (wlwmanifest) ausgeben
	<br /><input type="checkbox" name="plw123to_opt_nohv" value="1" <?php if($plw123to_options['use_noheaderver']) echo 'checked="checked"'; ?> /> Keine WP-Versionsinfo (generator) ausgeben
	<br /><input type="checkbox" name="plw123to_opt_nohl" value="1" <?php if($plw123to_options['use_noheaderrel']) echo 'checked="checked"'; ?> /> Keine Rel-Links (index,parent,start,adjacent) ausgeben</td></tr>
	<tr><th><label>Keine Versionsinfo: </label></th><td><input type="checkbox" name="plw123to_opt_nove" value="1" <?php if($plw123to_options['use_noversion']) echo 'checked="checked"'; ?> /> Die Ausgabe von Versionsinfos auf der Seite und im Feed wird unterdrückt (WP &gt;= 2.5)</td></tr>
	<tr><th><label>Version-Fake: </label></th><td><input name="plw123to_opt_verf" id="plw123to_opt_verf" value="<?php echo $plw123to_options['version_fake']; ?>" size="15" /><br /> Anstelle der WP-Versionsnummer wird dieser Text ausgegeben (leer=Version, - = leer)</td></tr>

	<tr><th><label>Keine Preview: </label></th><td><input type="checkbox" name="plw123to_opt_usnp" value="1" <?php if($plw123to_options['use_nopreview']) echo 'checked="checked"'; ?> /> Beim Bearbeiten unten keine Vorschau anzeigen (WP &lt; 2.2)</td></tr>
	<tr><th><label>Kein Upload: </label></th><td><input type="checkbox" name="plw123to_opt_usnu" value="1" <?php if($plw123to_options['use_noupload']) echo 'checked="checked"'; ?> /> Der Upload-Bereich unterhalb des Textfeldes (WP &lt; 2.5) bzw. die Mediathek (WP &gt;= 2.5) wird ausgeblendet </td></tr>
	<tr><th><label>Kein Bearbeiten: </label></th><td><input type="checkbox" name="plw123to_opt_usnd" value="1" <?php if($plw123to_options['use_noedit']) echo 'checked="checked"'; ?> /> Es können keine Beiträge oder Seiten erstellt oder bearbeitet werden</td></tr>
	<tr><th><label>Vorschaubildgröße: </label></th><td><input name="plw123to_opt_mths" id="plw123to_opt_mths" value="<?php echo $plw123to_options['max_thumbsize']; ?>" size="4" onchange="checkMTHS()" /><br /> Maximale Seitenlänge der erzeugten Vorschaubilder (0 = WP-Vorgabe 128) (WP &lt; 2.5)</td></tr>
	<tr><th><label>Sticky-Position: </label></th><td><input name="plw123to_opt_stpo" id="plw123to_opt_stpo" value="<?php echo $plw123to_options['sticky_offset']; ?>" size="2" onchange="checkSTPO()" /><br /> Sticky-Posts werden normalerweise ganz oben festgetackert. Der Wert legt einen Abstand von oben fest.  (WP &gt;= 2.7)</td></tr>
	<tr><th><label>Artikel-Vorbelegung: </label></th><td><textarea name="plw123to_opt_popf" cols="60" rows="5"><?php echo stripslashes( htmlspecialchars( $plw123to_options['post_prefill'] ) ); ?></textarea><br />Mit diesem Text wird ein neuer Artikel vorbelegt</td></tr>
	<tr><th><label>Seiten-Vorbelegung: </label></th><td><textarea name="plw123to_opt_pgpf" cols="60" rows="5"><?php echo stripslashes( htmlspecialchars( $plw123to_options['page_prefill'] ) ); ?></textarea><br />Mit diesem Text wird eine neue Seite vorbelegt</td></tr>
	<tr><th><label>Kein Host im Link: </label></th><td><input type="checkbox" name="plw123to_opt_usnh" value="1" <?php if($plw123to_options['use_nohostlink']) echo 'checked="checked"'; ?> /> Links werden ohne Hostnamen erzeugt (wurzelrelativ), aus 'http://example.com/page/' wird '/page/'
	<br /><input type="checkbox" name="plw123to_opt_usfh" value="1" <?php if($plw123to_options['use_feedhost']) echo 'checked="checked"'; ?> /> Links werden im Feed mit dem Hostnamen versehen (absolut), aus  '/page/ wird 'http://example.com/page/''</td></tr>
	</table>
<p class="submit">
	<input type="submit" name="plw123to_update" class="button-primary" value="<?php _e('Save Changes') ?>" />
</p>
  </form>
 </div>
 <?php 
}

function plw123to_add_admin_panel() {
	if (function_exists('add_options_page')) {
		add_options_page('123 Tools', '123 Tools', 8, basename(__FILE__), 'plw123to_options_subpanel');
    }
 }

add_action( 'admin_menu', 'plw123to_add_admin_panel' );

?>